Index: branches/2.5/expressoMail1_2/js/draw_api.js
===================================================================
--- branches/2.5/expressoMail1_2/js/draw_api.js	(revision 8188)
+++ branches/2.5/expressoMail1_2/js/draw_api.js	(revision 8232)
@@ -106,4 +106,5 @@
 			}
 			cExecute ("$this.imap_functions.get_folders_list&folder="+current_folder, update_tree_folders);
+            
 		}
 
@@ -239,6 +240,7 @@
 					var nn = new dNode({id:folders[i].folder_id, caption:lang_folder(folders[i].folder_name) + '<font style=color:red>&nbsp(</font><span id="dftree_'+folders[i].folder_id+'_unseen" style=color:red>'+folders[i].folder_unseen+'</span><font style=color:red>)</font>', onClick:"change_folder('"+folders[i].folder_id+"','"+folders[i].folder_name+"')", plusSign:folders[i].folder_hasChildren});
 
-					if( folders[i].folder_name.toLowerCase() == 'inbox' )
-						Element('new_m').innerHTML = '<font style="color:red">' + folders[i].folder_unseen + '</font>';
+
+					// if( folders[i].folder_name.toLowerCase() == 'inbox' )
+					// 	Element('new_m').innerHTML = '<font style="color:black">' + folders[i].folder_unseen + '</font>';
 				}
 				else
@@ -471,6 +473,4 @@
 		}
 	}
-	
-	outOfficeVerify();
 }
 
@@ -646,5 +646,8 @@
 		}
 		draw_new_tree_folder(false, forceLoadFolders);
-		draw_tree_labels();
+
+        if( preferences['use_followupflags_and_labels'] == "1" )
+            draw_tree_labels();
+
 		if(Element("table_quota"))
 			connector.loadScript("InfoQuota");
@@ -655,4 +658,5 @@
 
 var handler_draw_box = function(data){
+    populateSelectedMsgs(data.messagesIds);
 	draw_box(data, 'INBOX', true);
 	//alternate_border(0);
@@ -661,5 +665,8 @@
 // Action on change folders.
 function change_folder(folder, folder_name){
-	if (openTab.imapBox[0] != folder)
+	if (parseInt(preferences.use_dynamic_contacts) && $(".to").length && $(".to").data( "autocomplete" ).menu.active){
+        $(".to").data( "autocomplete" ).close();
+    }
+    if (openTab.imapBox[0] != folder)
 	{
 		selectAllFolderMsgs(false);
@@ -667,5 +674,5 @@
 		var handler_draw_box = function(data)
 		{
-
+            populateSelectedMsgs(data.messagesIds);
 			if(!verify_session(data))
 				return;
@@ -683,39 +690,9 @@
 			return true;
 		}
+
 		//MAILARCHIVE
         //se for pasta local
         if (/^local_messages/.test(current_folder)) {
             $(".folders-loading").removeClass("folders-loading"); //remove o icone de loading ao clicar nas pastas locais
-        }
-        else { //se não, processamento normal da pasta
-    		$.ajax({
-                async: false,
-    			url: "controller.php?" + $.param( {action: "$this.imap_functions.getMessagesIds", 
-    				folder: folder,
-    				 msg_range_begin: "0",
-    				 msg_range_end: "0", 					
-    				sort_box_type: "SORTARRIVAL", 
-    				search_box_type: search_box_type,
-    				sort_box_reverse: "1"
-    				}),
-    			success: function(data){
-    				data = connector.unserialize(data);
-    				if(data){
-    					var _data = {};
-    					$.each(data,function(index,value){
-    						if (data[index]){
-    							_data[data[index]] = data[index];
-    						}
-    					});
-    					populateSelectedMsgs(_data);
-    				}
-    			},
-    			beforeSend: function( jqXHR, settings ){
-    				connector.showProgressBar();
-    			},
-    			complete: function( jqXHR, settings ){
-    				connector.hideProgressBar();
-    			}
-    		});
         }
 		proxy_mensagens.messages_list(current_folder,1,preferences.max_email_per_page,sort_box_type,search_box_type,sort_box_reverse,preferences.preview_msg_subject,preferences.preview_msg_tip,handler_draw_box);
@@ -917,7 +894,7 @@
 	if (document.getElementById("table_message_header_box_"+numBox).emptyBody)
 		return;
-    objCell.style.cursor = "col-resize"; 
-    $(objCell).next().css('cursor','col-resize'); 
- 
+    objCell.style.cursor = "col-resize";
+    $(objCell).next().css('cursor','col-resize');
+
 	if (objCell.style.cursor == "col-resize" && detectLeftButton(ev)) {
 		var cellIndex = objCell.cellIndex;
@@ -942,5 +919,5 @@
 
 		document.getElementById("table_message_ruler").style.left = cellOffset+cellWidth;
-        syncColumns(); 
+        syncColumns();
 	}
 	ev.returnValue = false;
@@ -1649,7 +1626,8 @@
                     $(".lower").css("top", ($("#content_folders").height()-18) + $("#content_folders").offset().top);
 					if($(".shared-folders").length){
-						$(".shared-folders").parent().find('.folder:not(".shared-folders")').droppable({
+						$(".shared-folders,.head_folder").parent().find('.folder:not(".shared-folders")').droppable({
 							over : function(a, b){						
 								//SETA BORDA EM VOLTA DA PASTA
+                                $(b.helper).find(".draggin-folder,.draggin-mail").css("color", "green");
 								over = $(this);
 								$(this).addClass("folder-over");
@@ -1664,6 +1642,7 @@
 										}
 							},
-							out : function(){
+							out : function(a,b){
 								//RETIRA BORDA EM VOLTA DA PASTA
+                                $(b.helper).find(".draggin-folder,.draggin-mail").css("color", "");
 								$(this).removeClass("folder-over");
 							},
@@ -1723,7 +1702,16 @@
 			
                         $(this).addClass("selected_msg");
-					}
-					updateSelectedMsgs($(this).find("input:checkbox").is(':checked'),$(this).attr("id"));
-				}
+                }
+                updateSelectedMsgs($(this).find("input:checkbox").is(':checked'),$(this).attr("id"));
+                } else if ( typeof $(event.target).attr("style") == "undefined" || $(event.target).attr("style").match(/background/g) == null ) {
+                    if($(this).find("input:checkbox").attr("checked") != "checked"){
+
+                        $(this).find("input:checkbox").trigger('click');
+            
+                        $(this).addClass("selected_msg");
+                    }
+                    updateSelectedMsgs($(this).find("input:checkbox").is(':checked'),$(this).attr("id"));
+                }
+
 			});
 	}
@@ -1739,8 +1727,5 @@
 	draw_footer_box(headers_msgs.num_msgs);
 	Element('main_table').style.display = '';
-	if(is_ie6)	  // Stupid Fixing on IE6.
-		setTimeout("resizeWindow()",1);
-	else
-		resizeWindow();
+	resizeWindow();
 	if(debug) {
 		var _eTime = new Date();
@@ -1752,9 +1737,9 @@
 	var msg_number = Element('msg_number').value;
 	if(!msg_folder && msg_number) {
-        if ((msg_number.toString().indexOf('@') != -1) || !msg_number.toString().match(/[0-9]/)){ 
-            new_message_to(msg_number); 
-        }     
-        else 
-            new_message('new','null'); 
+        if ((msg_number.toString().indexOf('@') != -1) || !msg_number.toString().match(/[0-9]/)){
+            new_message_to(msg_number);
+        }    
+        else
+            new_message('new','null');
 	}
 	else if(msg_folder && msg_number){
@@ -1871,16 +1856,16 @@
                     //if (headers_msgs.msg_sample.body.length > 0)
 				    tr_element.msg_sample = Base64.decode(headers_msgs.msg_sample.body).substr(0,180) + "..."; //trecho do body que sera exibido com o assunto; //blabla
-			     } else {
+			        tr_element.msg_sample = html_entities(tr_element.msg_sample); 
+                 } else {
 				    //if (headers_msgs.msg_sample.body.length > 0)
 					tr_element.msg_sample = Base64.decode(headers_msgs.msg_sample.body).substr(0,120) + "..."; //trecho do body que sera exibido com o assunto;
-		          }
-
-                // preferencia dos tooltips
-                if(headers_msgs.msg_sample && preferences.preview_msg_tip == "1" && headers_msgs.msg_sample.body !== "") {
-                    tr_element.tip = Base64.decode(headers_msgs.msg_sample.body).substr(3,300) + "..."; //trecho do body que sera exibido no tool-tip;
-                }
+		            tr_element.msg_sample = html_entities(tr_element.msg_sample);  
+                  }
             }
         }
-
+        // preferencia dos tooltips
+        if(headers_msgs.msg_sample && preferences.preview_msg_tip == "1" && headers_msgs.msg_sample.body !== "") {
+            tr_element.tip = Base64.decode(headers_msgs.msg_sample.body).substr(3,300) + "..."; //trecho do body que sera exibido no tool-tip;
+        }
 		
 		if ((headers_msgs.Unseen == 'U') || (headers_msgs.Recent == 'N')){
@@ -1925,5 +1910,5 @@
 
 		if ((headers_msgs.Forwarded == 'F')  || (headers_msgs.Draft == 'X' && headers_msgs.Answered == 'A')){
-			td_element21.onclick=function(){search_emails(headers_msgs.subject.replace(/^(re: ?|fw: ?|enc: ?|res: ?|fwd: ?)*/gi,''),true);};
+			$(td_element21).on('click',function(){search_emails(headers_msgs.subject.replace(/^(re: ?|fw: ?|enc: ?|res: ?|fwd: ?)*/gi,''),true);});
                         td_element21.innerHTML = "<img src ='templates/"+template+"/images/forwarded.png' title='"+get_lang('Forwarded')+"'>";
 			headers_msgs.Draft = ''
@@ -1934,5 +1919,5 @@
 			td_element21.innerHTML = "<img src ='templates/"+template+"/images/draft.png' title='"+get_lang('Draft')+"'>";
 		else if (headers_msgs.Answered == 'A'){
-                        td_element21.onclick=function(){search_emails(headers_msgs.subject.replace(/^(re: ?|fw: ?|enc: ?|res: ?|fwd: ?)*/gi,''),true);};
+                        $(td_element21).on('click',function(){search_emails(headers_msgs.subject.replace(/^(re: ?|fw: ?|enc: ?|res: ?|fwd: ?)*/gi,''),true);});
 			td_element21.innerHTML = "<img src ='templates/"+template+"/images/answered.png' title='"+get_lang('Answered')+"'>";
                     }else
@@ -2048,10 +2033,12 @@
 						this.title = title_to; 
 					};
-					if (headers_msgs.to && headers_msgs.to[0]) {
+					if (headers_msgs.to && headers_msgs.to[0] != null) {
 						if (headers_msgs.to[0].name != null){
 							spanSender.innerHTML += headers_msgs.to[0].name;
 						}else if(headers_msgs.to[0].email != null) {
 							spanSender.innerHTML += headers_msgs.to[0].email;
-						}
+						}else {
+                            spanSender.innerHTML += get_lang("without destination");
+                        }
 					}
 				}else if(headers_msgs.from !== undefined){
@@ -2139,5 +2126,16 @@
 		$(td_element26).click(function() {	
 			var messageClickedId = $(this).attr('id').match(/td_message_followup_([\d]+)/)[1];
-			
+
+            var loading = $('#td_message_followup_' + messageClickedId + ', ' + 
+            'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+            .find('img[alt=Carregando]');
+
+
+            //Verificar se está carregando a bandeira.
+            //Caso esteja ele sai da função até que seja carregado. 
+            if( loading.length ) {
+                return false;
+            }
+
 			var followupColor = $('#td_message_followup_' + messageClickedId).find(".flag-edited").css('backgroundColor');
 			
@@ -2192,12 +2190,17 @@
 					
 					if(fail != 'success'){
-					    $('#td_message_followup_' + messageClickedId + ', ' + 
-					    'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "#CCCCCC")
-						.find('img').remove();
-					    MsgsCallbackFollowupflag[fail]();
+					    var msgFlag =  $('#td_message_followup_' + messageClickedId + ', ' + 
+                        'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "#CCCCCC");
+
+                        msgFlag.find('img').remove();
+                        
+                        //Insere a imagem da flag quando ocorre erro ao marcar a msg
+                        msgFlag.append("<img src='../prototype/modules/mail/img/flagEditor.png'/>");
+
+                        MsgsCallbackFollowupflag[fail]();
 					}else{
 					    $('#td_message_followup_' + messageClickedId + ', ' + 
 					    'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).attr('title', get_lang('Follow up')).find(".flag-edited").css("background", headers_msgs.followupflagged.backgroundColor)
-						.find('img').remove();
+						.append("<img src='../prototype/modules/mail/img/flagEditor.png'/>");
 					    updateCacheFollowupflag(messageClickedId, msg_folder, true);
 					}				
@@ -2215,5 +2218,4 @@
 					$('#td_message_followup_' + messageClickedId + ', ' + 
 					'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-					.css({"background-image":"url(../prototype/modules/mail/img/flagEditor.png)"})
 					.find('img').remove();
 					
@@ -2222,6 +2224,6 @@
 				
 					$('#td_message_followup_' + messageClickedId + ', ' + 
-						'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-                        .css({"background-image":"url(../prototype/modules/mail/img/flagEditor.png)"});
+						'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").html('<img src="../prototype/modules/mail/img/flagEditor.png">')
+                        .css({"width":"8px","height":"6px"/*"background-image":"url(../prototype/modules/mail/img/flagEditor.png)"*/});
 				});	
 
@@ -2229,7 +2231,16 @@
 				$('#td_message_followup_' + messageClickedId + ', ' + 
 				'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-				.css({"background-image":"url(../prototype/modules/mail/img/flagEditor.png)"}).css("background", followupColor);
+				.css("backgroundColor", followupColor)
+                .find('img').remove(); //remove imagem carregando da bandeira
+
+                $('#td_message_followup_' + messageClickedId).find('.flag-edited').append("<img src='../prototype/modules/mail/img/flagEditor.png'/>");
+
 				
-				$(tr_element).addClass('selected_msg').find(':checkbox').trigger('click');
+			   //Pega id do checkbox
+               var id = $(tr_element).addClass('selected_msg').find(':checkbox').attr('id');
+                
+                //Verifica se o checkbox está selecionado
+                if($('#' + id).attr('checked') != 'checked')
+                    $(tr_element).addClass('selected_msg').find(':checkbox').trigger('click');
 				
 				/**
@@ -2320,5 +2331,9 @@
 	var message_header = Element("message_header_"+search);
 	var handler_draw_box = function(data){
-		draw_box(data, current_folder,true);
+
+        if (typeof(clean_selected) == "undefined")
+            populateSelectedMsgs(data.messagesIds);
+
+        draw_box(data, current_folder,true);
 		//Mostrar as msgs nao lidas de acordo com o filtro de relevancia
         var msgs_unseen = 0;
@@ -2341,27 +2356,4 @@
 	sort_box_type = sort;
 	search_box_type = search;
-
-	if (typeof(clean_selected) == "undefined"){	
-        $.ajax({			
-			url: "controller.php?" + $.param( {action: "$this.imap_functions.getMessagesIds", 
-				folder: get_current_folder(),					
-				sort_box_type: "SORTARRIVAL", 
-				search_box_type: search_box_type,
-				sort_box_reverse: "1"
-				}),
-			success: function(data){
-				data = connector.unserialize(data);
-				if(data){
-					var _data = {};
-					$.each(data,function(index,value){
-						if (value){
-							_data[index] = value;
-						}
-					});
-					populateSelectedMsgs(_data);				
-				}
-			}
-		});
-	}	
 
 	proxy_mensagens.messages_list(current_folder,1,preferences.max_email_per_page,sort,search,sort_box_reverse,preferences.preview_msg_subject,preferences.preview_msg_tip,handler_draw_box);
@@ -2432,5 +2424,5 @@
 function draw_message(info_msg, ID){
 	// remove a flag $FilteredMessage da mensagem ao ser lida
-	if(info_msg.Unseen == "U"){
+	if(info_msg.Unseen == "U" && preferences['use_alert_filter_criteria'] == "1"){
 		$.each(fromRules, function(index, value) {
 			if(value == info_msg.msg_folder){
@@ -2479,8 +2471,8 @@
 			{
                 if(info_msg.msg_number.match("s[0-9]+")){
-                    var new_info = info_msg.msg_number;
-                    new_info = new_info.split("_")[1];
-                    info_msg.next_message = info_msg.next_message+"_"+new_info;
-                    info_msg.nextMsgBox = info_msg.nextMsgBox+"_"+new_info;
+                    var msg_next = $('#'+info_msg.msg_number).next();
+                    info_msg.next_message = msg_next.attr("id");
+                    info_msg.nextMsgBox = msg_next.attr("name");
+                    nextMsgBox = msg_next.attr("name");
                 }
 				currentTab = ID;
@@ -2489,5 +2481,6 @@
 				//select_msg('null', 'down', true);
 				if (!msg_selected){
-					select_msg('null', 'down', true);
+					if(!!parseInt(preferences.use_shortcuts))
+                        select_msg('null', 'down', true);
 					msg_selected = true;
 				}
@@ -2495,5 +2488,5 @@
 		}
 		/*Ultima mensagem de cada página, exceto a ultima*/
-        else if( (current_page < total_pages) ){
+        else if( (current_page < total_pages) && !info_msg.msg_number.match("s[0-9]+") ){
 		   
 		   img_next_msg.onclick = function()
@@ -2559,8 +2552,8 @@
 			{
                 if(info_msg.msg_number.match("s[0-9]+")){
-                    var new_info = info_msg.msg_number;
-                    new_info = new_info.split("_")[1];
-                    info_msg.prev_message = info_msg.prev_message+"_"+new_info;
-                    info_msg.previousMsgBox = info_msg.previousMsgBox+"_"+new_info;
+                    var msg_prev = $('#'+info_msg.msg_number).prev();
+                    info_msg.prev_message = msg_prev.attr("id");
+                    info_msg.previousMsgBox = msg_prev.attr("name");
+                    previousMsgBox = msg_prev.attr("name");
                 }
 				currentTab = ID;
@@ -2569,5 +2562,6 @@
 				//select_msg('null', 'up', false);
 				if (!msg_selected){
-					select_msg('null', 'up', true);
+                    if(!!parseInt(preferences.use_shortcuts))
+					    select_msg('null', 'up', true);
 					msg_selected = true;
 				}
@@ -3010,5 +3004,7 @@
 		var option_export = '<span onclick="proxy_mensagens.export_all_messages()" onmouseover="this.className=\'reply_options_active\'" onmouseout="this.className=\'reply_options\'" class="reply_options">'+get_lang("Export")+'</span> | ';
 		var report_error = '<span onmouseover="this.className=\'reply_options_active\'" onmouseout="this.className=\'reply_options\'" class="reply_options" onclick=reports_window("'+currentTab+'");>'+get_lang("Report error")+'</span> | '; 
-		div_other_more_options.innerHTML += option_move + option_print + option_export + block_user +  report_error;
+		// Opção do menu 'Mais Ações' para criar filtro a partir da mensagem aberta:  
+		var option_create_filter = '<span onmouseover="this.className=\'reply_options_active\'" onmouseout="this.className=\'reply_options\'" class="reply_options" onclick=filter_from_msg(onceOpenedHeadersMessages[\'' + html_entities(info_msg.msg_folder) + '\'][' + info_msg.msg_number + ']);>' + get_lang("Create filter from message") + '</span> | '; 
+		div_other_more_options.innerHTML += option_create_filter + option_move + option_print + option_export + block_user +  report_error;
 		
 		
@@ -3509,5 +3505,5 @@
 	subject.innerHTML = html_entities(info_msg.subject); 
 	subject.className = "header_message_field";
-	if(defaultCalendar == "expressoCalendar" && $("#expressoCalendarid")[0]){
+	if($("#expressoCalendarid")[0]){
 		var new_task_logo = document.createElement("IMG");
 		new_task_logo.title = "Criar uma nova tarefa a partir deste email.";
@@ -4644,24 +4640,17 @@
             delay : 300,
             minLength: 0
-        }).bind('catcompleteopen', function(event, ui) {
+        }).bind('autocompleteopen', function(event, ui) {
 
             $(this).data('is_open',true);
 
-        }).bind('catcompleteclose', function(event, ui) {
+        }).bind('autocompleteclose', function(event, ui) {
 
             canMakeBox = true;
             $(this).data('is_open',false);
-
+            $(this).blur().focus();
         }).data( "autocomplete" )._renderItem = function( ul, item ) {
             var autocomplete = $(this)[0].element;
 
-            //cálculo dinâmico da largura da lista
-            var minwidth = 450;
-            var width = (item.label ? item.label.length : (item.value ? item.value.length : (item.mail ? item.mail.length : 30 )));
-            width = (is_ie ? width*2 : (is_webkit && !is_mozilla ? width*4 : width*5)) + 30;
-            if (width < minwidth)
-                width = minwidth;
-
-            ul.css({"min-width":width, "max-height" : "180px", "overflow-y" : "auto", "min-height": "30px"});
+            ul.css({"width":'50%',"min-width":'600px', "max-height" : "180px", "overflow-y" : "auto", "min-height": "30px"});
 
             item.raty = ((item.number_of_messages*10)/topContact) > 1 ? ((item.number_of_messages*10)/topContact) : 1;
@@ -4753,4 +4742,132 @@
 			emQuickSearch(($(this).parents("tr:first").find("textarea").val() ? $(this).parents("tr:first").find("textarea").val() : input_search), "."+$(this).parents("tr:first").attr('class').split("-")[0], ID, undefined, true);
 	});
+}
+
+/* 
+	Anexa uma mensagem a mensagem sendo enviada. 
+	Parâmetros: 
+		folder_name: nome da pasta na qual a mensagem sendo anexada se encontra. 
+		message_number: id da mensagem sendo anexada. 
+*/ 
+function attach_message (folder_name, message_number) { 
+    var ID = currentTab; 
+    var fileUploadMSG = $('#fileupload_msg'+ID); 
+    fileUploadMSG.find(' .attachments-list').show(); 
+    var att = new Object(); 
+
+   
+
+    var attach = {}; 
+    attach.fileName = onceOpenedHeadersMessages[folder_name][message_number].subject + '.eml'; 
+    attach.fullFileName = onceOpenedHeadersMessages[folder_name][message_number].subject + '.eml'; 
+    if(attach.fileName.length > 20){ 
+        attach.fileName = attach.fileName.substr(0, 17) + "... " + attach.fileName.substr(attach.fileName.length - 9, attach.fileName.length); 
+    } 
+    attach.error = false; 
+    attach.OK = true;
+    if (folder_name.indexOf('local_messages_') == 0){
+        attach.fileSize = formatBytes(onceOpenedHeadersMessages[folder_name][message_number].size);
+    } else {
+        attach.fileSize = formatBytes(onceOpenedHeadersMessages[folder_name][message_number].Size); 
+    }
+    var upload = $(DataLayer.render("../prototype/modules/mail/templates/attachment_add_itemlist.ejs", { 
+        file: attach 
+    })); 
+    $("#content_id_" + currentTab + " .save").button("enable"); 
+    upload.find('.att-box-loading').remove(); 
+    upload.append('<input type="hidden" name="fileId[]" value=\'' + idATT + '\'/>'); 
+ 
+    upload.find('.att-box-delete').click(function() 
+    { 
+        $("#content_id_" + currentTab + " .save").button("enable"); 
+        var idAttach = $(this).parent().find('input[name="fileId[]"]').val(); 
+        fileUploadMSG.find(' .attachments-list').find('input[value="' + idAttach + '"]').remove(); 
+        delAttachment(ID, idAttach); 
+        $(this).parent().qtip("destroy"); 
+        $(this).parent().remove(); 
+        if(!fileUploadMSG.find(' .attachments-list').find(".att-box").length) 
+        { 
+            fileUploadMSG.find(' .attachments-list').hide(); 
+        } 
+    }); 
+ 
+    var addtip = function(attach){
+        fileUploadMSG.find('.attachments-list .att-box:last').qtip( 
+        { 
+            content: DataLayer.render("../prototype/modules/mail/templates/attachment_add_itemlist_tooltip.ejs", { 
+                attach: attach 
+            }), 
+            position: { 
+                corner: { 
+                    tooltip: 'bottomMiddle', 
+                    target: 'topMiddle' 
+                }, 
+                adjust: { 
+                    resize: true, 
+                    scroll: true 
+                } 
+            }, 
+            show: { 
+                when: 'mouseover', 
+                // Don't specify a show event 
+                ready: false // Show the tooltip when ready 
+            }, 
+            hide: 'mouseout', 
+            // Don't specify a hide event 
+            style: { 
+                border: { 
+                    width: 1, 
+                    radius: 5 
+                }, 
+                width: { 
+                    min: 75, 
+                    max: 1000 
+                }, 
+                padding: 5, 
+                textAlign: 'center', 
+                tip: true, 
+                // Give it a speech bubble tip with automatic corner detection 
+                name: 'blue' // Style it according to the preset 'cream' style 
+            } 
+        }); 
+    } 
+
+    if(folder_name.indexOf("local_messages_") != 0)
+    {
+        att.folder = folder_name; 
+        att.uid = message_number; 
+        att.type = 'imapMSG'; 
+        att.name = Base64.encode(onceOpenedHeadersMessages[folder_name][message_number].subject + '.eml'); 
+        var idATT = JSON.stringify(att); 
+        addAttachment(ID, idATT); 
+
+        fileUploadMSG.find('.attachments-list').append(upload);
+        addtip(attach);
+    }
+    else
+    {
+        var folder_trash = "INBOX"+cyrus_delimiter+special_folders["Trash"];
+        expresso_mail_archive.unarchieveToAttach(folder_name, folder_trash, message_number, function(data){
+            $.ajax({
+                url: "controller.php?action=$this.imap_functions.get_info_msg_archiver",
+                data:  {"idMsgs":data.idsMsg},
+                type: 'POST',
+                async: false,
+                success: function(data){
+                    data = JSON.parse(connector.unserialize(data));
+                    data = data[0];
+                    att.folder = folder_trash;
+                    att.uid = data.uid; 
+                    att.type = 'imapMSG'; 
+                    att.name = Base64.encode(onceOpenedHeadersMessages[folder_name][message_number].subject + '.eml'); 
+                    var idATT = JSON.stringify(att); 
+                    addAttachment(ID, idATT);
+                    fileUploadMSG.find('.attachments-list').append(upload);
+                    addtip(attach);
+                },
+            });
+        }); 
+    }
+    upload.find('.att-box-loading').remove();     
 }
 		
@@ -4933,9 +5050,7 @@
     	$(this).prev().show();
 	});
-	fileUploadMSG.find(".fileUploadButton, .message-attach-link").button().filter(".fileUploadButton").click(function(){
-            fileUploadMSG.find("input:file").trigger("click");
-    });
-
-    fileUploadMSG.find("input:file").fileupload({
+
+
+    fileUploadMSG.find(".button").button().filter(".fileinput-button").find(".ui-button-text").css("margin-top","2px").find("input:file").fileupload({
 		//singleFileUploads : true,fileUploadMSG
 		sequentialUploads: true, 
@@ -5113,11 +5228,15 @@
             });
         }*/
-	});/*.css({
-		"height" : "20px", 
-		"width": (is_webkit ? "205px" : "100px"), 
-		"border-width": "0 0 0px 0px", 
-        "-moz-transform" : "rotate(-180deg) translate(5px, -0.5px) scale(1.1)",  
-        "-webkit-transform" : "rotate(-180deg) translate(0px, 0px)"
-	}).end().end().end().*/
+	}).css({
+        "height" : ($.browser.mozilla ? "15px" : "20px"), 
+        // "width": (is_webkit ? "205px" : "100px"),
+        "width" : "205px",
+        "margin-top" : ($.browser.mozilla ? "10px" : "0"),
+        "margin-right" : (is_mozilla ? "30px" : "0"),
+        "border-width": "0 0 0px 0px", 
+        "transform" : "rotate(-360deg) translate(5px, -0.5px) scale(1.1)",  
+        "-webkit-transform" : "rotate(-360deg) translate(0px, 0px)"
+	});/*.end().end().end().*/
+
     fileUploadMSG.find(".message-attach-link").click(function(){
 		jQuery('#message-attach-dialog').html(DataLayer.render("../prototype/modules/attach_message/attach_message.ejs", {}));
@@ -5149,74 +5268,7 @@
 				jQuery.each(selectedMessages[folder_name], function(message_number, message) { 
 					if (message) {
-						fileUploadMSG.find(' .attachments-list').show();	
-						var att = new Object();
-						att.folder = folder_name;
-						att.uid = message_number;
-						att.type = 'imapMSG';
-						att.name = Base64.encode(onceOpenedMessages[folder_name][message_number].subject + '.eml');
-						var idATT = JSON.stringify(att);
-						addAttachment( ID , idATT);                        
-						var attach = {};
-						attach.fileName = onceOpenedMessages[folder_name][message_number].subject + '.eml';
-						attach.fullFileName = onceOpenedMessages[folder_name][message_number].subject + '.eml';
-						if(attach.fileName.length > 20)
-							attach.fileName = attach.fileName.substr(0, 17) + "... " + attach.fileName.substr(attach.fileName.length-9, attach.fileName.length);
-
-						attach.error = false;
-                        attach.OK = true;
-						attach.fileSize = formatBytes(onceOpenedMessages[folder_name][message_number].size);
-						var upload = $(DataLayer.render("../prototype/modules/mail/templates/attachment_add_itemlist.ejs", {file : attach}));
-						$("#content_id_"+currentTab+" .save").button("enable");
-                        upload.find('.att-box-loading').remove();
-						upload.append('<input type="hidden" name="fileId[]" value=\''+idATT+'\'/>');
-						
-						upload.find('.att-box-delete').click(function(){
-                            $("#content_id_"+currentTab+" .save").button("enable");
-							var idAttach = $(this).parent().find('input[name="fileId[]"]').val();
-							fileUploadMSG.find(' .attachments-list').find('input[value="'+idAttach+'"]').remove();
-							delAttachment(ID,idAttach); 
-							$(this).parent().qtip("destroy");
-							$(this).parent().remove();
-							if(!fileUploadMSG.find(' .attachments-list').find(".att-box").length){
-								fileUploadMSG.find(' .attachments-list').hide();
-							}
-						});	
-							
-						fileUploadMSG.find('.attachments-list').append(upload);
-
-						upload.find('.att-box-loading').remove();
-
-						fileUploadMSG.find('.attachments-list .att-box:last').qtip({
-		                	content: DataLayer.render("../prototype/modules/mail/templates/attachment_add_itemlist_tooltip.ejs", {attach : attach}),
-							position: {
-								corner: {
-									tooltip: 'bottomMiddle',
-									target: 'topMiddle'
-								},
-								adjust: {
-					               resize: true,
-					               scroll: true
-					            }
-							},
-							show: {
-								when: 'mouseover', // Don't specify a show event
-								ready: false // Show the tooltip when ready
-							},
-							hide: 'mouseout', // Don't specify a hide event
-							style: {
-								border: {
-									width: 1,
-									radius: 5
-								},
-								width: {
-									 min: 75,
-									 max : 1000
-								},
-								padding: 5, 
-								textAlign: 'center',
-								tip: true, // Give it a speech bubble tip with automatic corner detection
-								name: 'blue' // Style it according to the preset 'cream' style
-							}
-		                });
+						/* Anexa a mensagem especificada (por folder e id_msg) 
+						   na mensagem sendo criada.*/
+						attach_message(folder_name, message_number);
 					}
 				});
@@ -5781,13 +5833,13 @@
 }
 
-function verifyContext(type) { 
-    var folderN = $(".menu-sel").attr("role") ? $(".menu-sel").attr("role") : get_current_folder(); 
-    if(type == "unarchive"){ 
-        expresso_mail_archive.unarchieve(folderN, null, null); 
-    } else { 
-        archive_msgs(folderN,null,null) 
-    } 
-} 
- 
+function verifyContext(type) {
+    var folderN = $(".menu-sel").attr("role") ? $(".menu-sel").attr("role") : get_current_folder();
+    if(type == "unarchive"){
+        expresso_mail_archive.unarchieve(folderN, null, null);
+    } else {
+        archive_msgs(folderN,null,null)
+    }
+}
+
 function draw_footer_box(num_msgs){
 	folder = get_current_folder();
